
.build_template_macos: &build_template_macos
    stage: build_and_test
    interruptible: true
    tags:
        - macos
    except:
        - /(nobuild)/
        - /(noci)/
        - main@MoReFEM/CoreLibrary/MoReFEM
    variables:
        BUILD_DIR: "build_${CI_PROJECT_ID}_${CI_COMMIT_REF_SLUG}_${OS}-${COMPILER}-${MODE}-${LIB_NATURE}-${IS_ONLY_ONE_LIB}"
    cache:
        key: "cache_${CI_PROJECT_ID}_${CI_COMMIT_REF_SLUG}_${OS}-${COMPILER}-${MODE}-${LIB_NATURE}-${IS_ONLY_ONE_LIB}"
        untracked: true
        paths:
            - ${BUILD_DIR}
    artifacts:
        name: "artifact_${CI_PROJECT_ID}_${CI_COMMIT_REF_SLUG}_${OS}-${COMPILER}-${MODE}-${LIB_NATURE}-${IS_ONLY_ONE_LIB}"
        expire_in: 5 days
        when: always
        paths:
            - ${BUILD_DIR}/compilation.log
    script:
        - rm -rf ${BUILD_DIR}
        - mkdir ${BUILD_DIR}
        - cd ${BUILD_DIR} && python3 ../cmake/Scripts/configure_cmake.py --cache_file=../cmake/PreCache/runner-macos.cmake  --cmake_args="-G Ninja"  --third_party_directory=/Users/Shared/opt/clang_${MODE} --mode=${MODE} --library_type=${LIB_NATURE}  --morefem_as_single_library=${IS_ONLY_ONE_LIB} --morefem_with_slepc=True
        - ninja 2>&1 | tee compilation.log
        - ctest --output-on-failure


.check_compilation_warning_template_macos: &check_compilation_warning_template_macos
    stage: check_warnings
    interruptible: true
    except:
        - /(nobuild)/
        - /(noci)/
        - main@MoReFEM/CoreLibrary/MoReFEM
    # dependencies: in the instantiations!
    variables:
        BUILD_DIR: "build_${CI_PROJECT_ID}_${CI_COMMIT_REF_SLUG}_${OS}-${COMPILER}-${MODE}-${LIB_NATURE}-${IS_ONLY_ONE_LIB}"
    script:
        - python3 Scripts/Tools/find_warning_in_compilation_log.py --log ${BUILD_DIR}/compilation.log
    allow_failure: true


build_macos_clang_debug_several_static_libraries:
  extends: .build_template_macos
  tags:
      - macos
  variables:
      OS: "macos"
      COMPILER: "clang"
      MODE: "debug"
      LIB_NATURE: "static"
      OS: "macos"
      IS_ONLY_ONE_LIB: "False"

check_macos_clang_debug_several_static_libraries:
  extends: .check_compilation_warning_template_macos
  needs: [build_macos_clang_debug_several_static_libraries]
  tags:
      - macos
  dependencies:
      - build_macos_clang_debug_several_static_libraries
  variables:
      OS: "macos"
      COMPILER: "clang"
      MODE: "debug"
      LIB_NATURE: "static"
      OS: "macos"
      IS_ONLY_ONE_LIB: "False"


build_macos_clang_release_one_static_library:
  extends: .build_template_macos
  tags:
      - macos
  variables:
      OS: "macos"
      COMPILER: "clang"
      MODE: "release"
      LIB_NATURE: "static"
      OS: "macos"
      IS_ONLY_ONE_LIB: "True"

check_macos_clang_release_one_static_library:
  extends: .check_compilation_warning_template_macos
  needs: [build_macos_clang_release_one_static_library]
  tags:
      - macos
  dependencies:
      - build_macos_clang_release_one_static_library
  variables:
      OS: "macos"
      COMPILER: "clang"
      MODE: "release"
      LIB_NATURE: "static"
      OS: "macos"
      IS_ONLY_ONE_LIB: "True"

